/*
 * Copyright (c) 2009 Apple Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * This file contains Original Code and/or Modifications of Original Code
 * as defined in and that are subject to the Apple Public Source License
 * Version 2.0 (the 'License'). You may not use this file except in
 * compliance with the License. Please obtain a copy of the License at
 * http://www.opensource.apple.com/apsl/ and read it before using this
 * file.
 * 
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
 * Please see the License for the specific language governing rights and
 * limitations under the License.
 * 
 * @APPLE_LICENSE_HEADER_END@
 */
#include <stdio.h>  // fprintf(), NULL
#include <stdlib.h> // exit(), EXIT_SUCCESS
#include <mach-o/dyld.h>
#include <string.h>
#include "test.h" // PASS(), FAIL(), XPASS(), XFAIL()


//
//  <rdar://problem/6563887> app crashes when libSystem cannot be found
//

int main() 
{
	// see if libSystem is in list of images
	uint32_t count = _dyld_image_count();
	for(uint32_t i=0; i < count; ++i) {
		const char*  name = _dyld_get_image_name(i);
		if ( strstr(name, "/libSystem.") != NULL ) {
			PASS("always-libSystem");
			return 0;
		}
	}

	FAIL("always-libSystem");
	return 0;
}

